# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 Domsense s.r.l. (<http://www.domsense.com>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


{
    "name": "VAT on cash receipts",
    "version": "1.0",
    'category': 'Generic Modules/Accounting',
    "depends": ["account_voucher"],
    "author": "Agile Business Group & Domsense",
    "description": """In some countries, under certain conditions, companies can apply the 'Cash Receipts' basis.\n
    The 'Cash Receipts' basis means businesses may account for VAT as cash comes in from their customers. 
    It is easier to manage than the normal method, which forces businesses to account for VAT based on invoices issued,
    regardless of whether or not the money has come in.\n
    The key advantage to accounting for VAT on a cash receipts basis is the cashflow benefit to your business.
    The effect of the cash receipts basis is that you only become liable for VAT when you have actually received payment,
    so you don't have to fund the VAT on your debtors. 
    This is particularly helpful in a startup situation and in the case of an expanding business.\n\n
    To activate this behaviour, this module adds a checkbox on the invoice form: 'Vat on cash receipts'\n\n
    Moreover, three things have to be configured:\n 
    - On account object, Related account used for real registrations on a VAT on cash basis\n 
    - On journal object - Related journal used for real registrations on a VAT on cash basis (optional)\n 
    - On tax code object, Related tax code used for real registrations on a VAT on cash basis (optional)""",
    'website': 'http://www.agilebg.com',
    'init_xml': [],
    'update_xml': [
        'account_view.xml',
        ],
    'demo_xml': [],
    'installable': True,
    'active': False,
}
