# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Module: l10n_hr....
#    Author: Goran Kliska
#    mail:   gkliskaATgmail.com
#    Copyright (C) 2011- Slobodni programi d.o.o., Zagreb
#    Contributions: 
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import decimal_precision as dp
import time

from osv import fields, osv

from tools.translate import _
import pooler


#poziv na broj i slicno
class account_journal(osv.osv):
    _inherit = "account.journal"
    _columns = {
        'model_pnbr': fields.selection([(''  ,'Bez modela'), 
                                   ('00','Bez kontrole'),
                                   ('02','P1-P2[k(P2)]-P3[k(P3)]'),
                                   ('03','P1[k(P1)]-P2[k(P2)]-P3[k(P3)]'),
                                   ('06','P1-P2-P3[k(P2,P3)]'),
                                   ('99','Bez kontrole'),
                                  ], 
                                  'Model', 
                             help='Model poziva na broj'),
    }

    def create_sequence(self, cr, uid, vals, context=None):
        """
        Create new entry sequence for every new Joural
        @param cr: cursor to database
        @param user: id of current user
        @param ids: list of record ids to be process
        @param context: context arguments, like lang, time zone
        @return: return a result
        """
        seq_pool = self.pool.get('ir.sequence')
        seq_typ_pool = self.pool.get('ir.sequence.type')

        name = vals['name']
        code = vals['code'].lower()

        types = {
            'name': name,
            'code': code
        }
        seq_typ_pool.create(cr, uid, types)

        seq = {
            'name': name,
            'code': code,
            'active': True,
            'prefix': "%(y)s-",
            'padding': 4,
            'number_increment': 1
        }
        return seq_pool.create(cr, uid, seq)

account_journal()

            
class account_move(osv.osv):
    _inherit = "account.move"
            
    _columns = {
                'move_type': fields.selection([
                              ('initial','Initial'), 
                              ('opening','Opening New FY'),
                              ('regular','Regular'),
                              ('closing','Closing FY'),
                              ],
                              help='Initial: Initial state used for starting with OpenERP'\
                                   'Opening: Opening moves for new year start'\
                                   'Regular: Regular moves trought fiscal year'\
                                   'Closing: Closing moves at the end of the fiscal year'\
                              )                 
                
               }
    _defaults = {
                 'move_type': 'regular',
                }



account_move()










