
# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2011 Storm Computers d.o.o. All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv

class product_category (osv.osv):
    _name = "product.category"
    _inherit = "product.category"
    _columns = {
        #'inventory_vat_group'
        #'Landing cost expense account'
		'product_type': fields.selection([('product','Stockable Product'),('consu', 'Consumable'),('service','Service')], 'Product Type', required=True, help="Will change the way procurements are processed. Consumables are stockable products with infinite stock, or for use when you have no inventory management in the system."),
		'supply_method': fields.selection([('produce','Produce'),('buy','Buy')], 'Supply method', required=True, help="Produce will generate production order or tasks, according to the product type. Purchase will trigger purchase orders when requested."),
        "cost_method": fields.selection([("standard","Standard Price"),("average","Average Price"),("fifo","FIFO"),("lot","Specific Lot")],"Costing Method",required=True),
		'purchase_requisition': fields.boolean('Purchase Requisition', help="Check this box so that requisitions generates purchase requisitions instead of directly requests for quotations."),
		'procure_method': fields.selection([('make_to_stock','Make to Stock'),('make_to_order','Make to Order')], 'Procurement Method', required=True, help="'Make to Stock': When needed, take from the stock or wait until re-supplying. 'Make to Order': When needed, purchase or produce for the procurement request."),
        'valuation':fields.selection([('manual_periodic', 'Periodical (manual)'),
                                      ('real_time','Real Time (automated)'),], 'Inventory Valuation',
                                    help="If real-time valuation is enabled for a product, the system will automatically write journal entries corresponding to stock moves." \
                                            "The inventory variation account set on the product category will represent the current inventory value, and the stock input and stock output account will hold the counterpart moves for incoming and outgoing products."
                                    , required=True),
    }
    _defaults = {
        'cost_method': lambda *a: 'fifo',
        'procure_method': lambda *a: 'make_to_stock',
        'valuation': lambda *a: 'real_time',
        }
product_category()